<?php

/**
 * This software is intended for use with Oxwall Free Community Software http://www.oxwall.org/ and is
 * licensed under The BSD license.

 * ---
 * Copyright (c) 2011, Oxwall Foundation
 * All rights reserved.

 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that the
 * following conditions are met:
 *
 *  - Redistributions of source code must retain the above copyright notice, this list of conditions and
 *  the following disclaimer.
 *
 *  - Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 *  the following disclaimer in the documentation and/or other materials provided with the distribution.
 *
 *  - Neither the name of the Oxwall Foundation nor the names of its contributors may be used to endorse or promote products
 *  derived from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO CHALLENGE SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
$plugin = OW::getPluginManager()->getPlugin('challenge');
$router = OW::getRouter();
$router->addRoute(new OW_Route('challenge.add', 'challenge/add', 'CHALLENGE_CTRL_Base', 'add'));
$router->addRoute(new OW_Route('challenge.edit', 'challenge/edit/:challengeId', 'CHALLENGE_CTRL_Base', 'edit'));
$router->addRoute(new OW_Route('challenge.delete', 'challenge/delete/:challengeId', 'CHALLENGE_CTRL_Base', 'delete'));
$router->addRoute(new OW_Route('challenge.view', 'challenge/:challengeId', 'CHALLENGE_CTRL_Base', 'view'));
$router->addRoute(new OW_Route('challenge.main_menu_route', 'challenges', 'CHALLENGE_CTRL_Base', 'challengesList', array('list' => array(OW_Route::PARAM_OPTION_HIDDEN_VAR => 'latest'))));
$router->addRoute(new OW_Route('challenge.view_challenge_list', 'challenges/:list', 'CHALLENGE_CTRL_Base', 'challengesList'));
$router->addRoute(new OW_Route('challenge.main_user_list', 'challenge/:challengeId/users', 'CHALLENGE_CTRL_Base', 'challengeUserLists', array('list' => array(OW_Route::PARAM_OPTION_HIDDEN_VAR => 'yes'))));
$router->addRoute(new OW_Route('challenge.user_list', 'challenge/:challengeId/users/:list', 'CHALLENGE_CTRL_Base', 'challengeUserLists'));
$router->addRoute(new OW_Route('challenge.private_challenge', 'challenge/:challengeId/private', 'CHALLENGE_CTRL_Base', 'privateChallenge'));
$router->addRoute(new OW_Route('challenge.invite_accept', 'challenge/:challengeId/:list/invite_accept', 'CHALLENGE_CTRL_Base', 'inviteListAccept'));
$router->addRoute(new OW_Route('challenge.invite_decline', 'challenge/:challengeId/:list/invite_decline', 'CHALLENGE_CTRL_Base', 'inviteListDecline'));

$challengeHandler = new CHALLENGE_CLASS_ChallengeHandler();
$challengeHandler->genericInit();
$challengeHandler->init();
